import { AbstractControlOptions, AsyncValidatorFn, FormBuilder, ValidatorFn } from '@angular/forms';
import { ClassConstructor } from 'class-transformer';
import 'reflect-metadata';
import { DynamicFormBuilderOptions } from '../types/dynamic-form-builder-options';
import { DynamicFormGroupConfig } from '../types/dynamic-form-group-config';
import { FormModel } from '../types/form-model';
import { DynamicFormGroup } from './dynamic-form-group';
export declare class DynamicFormBuilder extends FormBuilder {
    protected options?: DynamicFormBuilderOptions | undefined;
    protected emptyDynamicFormGroup: DynamicFormGroup<Object>;
    constructor(options?: DynamicFormBuilderOptions | undefined);
    group<TModel>(factoryModel: ClassConstructor<TModel>, controlsConfig?: FormModel<TModel> | DynamicFormGroupConfig | {
        [key: string]: any;
    }, options?: AbstractControlOptions | DynamicFormGroupConfig): DynamicFormGroup<TModel>;
    protected factoryFormBuilder(): FormBuilder;
    factoryDynamicFormGroup<TModel>(factoryModel: ClassConstructor<TModel>, fields?: FormModel<TModel>, validatorOrOpts?: ValidatorFn | ValidatorFn[] | AbstractControlOptions | null, asyncValidator?: AsyncValidatorFn | AsyncValidatorFn[] | null, options?: DynamicFormGroupConfig): DynamicFormGroup<TModel>;
    /**
     * Recursively creates an empty object from the data provided
     */
    protected createEmptyObject<TModel>(factoryModel: ClassConstructor<TModel>, data?: {}): any;
}
